<?php

/**
 * no_retroactivo_def actions.
 *
 * @package    nomina
 * @subpackage no_retroactivo_def
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class no_retroactivo_defActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a executeAdd");


        $records = array();
        $arrayConstantes = array();


        /*
         * Abrir conexion transaccion
         */
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        /*
         * Formato de fecha
         */
        //Sql
        $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD" 
EOD;
        //Ejecutar SQL
        CN_TABLE::executeSQL($sql);
        $arrayConstantes = array();

        /*
         * Manejar Errores
         */
        try {


            /**
             * Consultar salario minimo
             */
            $salario_minimo = 550000;
            //Sql
            $sql = <<<EOD
(select nvl(valor_mensual, 0) as valor_mensual from no_smdlv where vigencia = extract(year from sysdate))  
EOD;
            //Ejecutar SQL
            $record_smlv = CN_TABLE::executeSQL($sql);

            if (count($record_smlv) > 0) {
                //No se debe redondear - 20130802
//                $salario_minimo = round($record_smlv[0]['valor_mensual'], -3);
                $salario_minimo = round($record_smlv[0]['valor_mensual']);
            }

            /*
             * Obtener consultas glodal
             */
            //Sql
            $sql = <<<EOD
select * from NO_CONSULTA 
EOD;
            //Ejecutar SQL
            $record_consul = CN_TABLE::executeSQL($sql);
            $record_consulta = array();

            if (count($record_consul) > 0) {
                foreach ($record_consul as $key => $value) {
                    $record_consulta[$value['caracter']] = $value;

//                    $this->logMessage("Caracter - " . $value['caracter']);
                }
            }
//            $this->logMessage("Consulta - " . $record_consulta['M']['consulta']);
//            die();

            /**
             * Cargar tabla constantes
             */
            $text = '$con_';
            //Constantes 
            $sql = <<<EOD
Select cons.*, '$text'|| cons.id_constante as reemplazo from no_constante cons 
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);


            //Agrega a un array todas las constantes
            foreach ($records as $value) {

//                foreach ($value as $key => $value2) {
//                    $this->logMessage($key . " - " . $value2);
//                }

                $arrayConstantes[$value['reemplazo']] = $value;
//                $this->logMessage($value['reemplazo'] . "------------------------" . $arrayConstantes[$value['reemplazo']]);
            }

            //PARAMETROS
            $id_periodo_actual = $request['id_periodo'];
            $id_periodo = $periodo = $request['id_periodo_filtro'];
            $id_periodo_aju_men = $id_periodo_ini = $request['id_periodo_ini'];
            $id_periodo_fin = $request['id_periodo_fin'];
            $progress_key = $request['progress_key'] . $request['username'];

            //Sql
            $sql = <<<EOD
select 
definitivo as definitivo,
fecha_ini as fecha_desde_tipter,
fecha_fin as fecha_hasta_tipter,
id_anhos as id_anhos_tipter,
id_meses as id_meses_tipter, 
nvl(id_tipo_periodo,0) as id_tipo_periodo 
from no_periodo 
    where id_periodo = $id_periodo 
EOD;
            //Ejecutar SQL
            $record_tipper = CN_TABLE::executeSQL($sql);
            $definitivo = $record_tipper[0]['definitivo'];
            $id_tipo_periodo = $record_tipper[0]['id_tipo_periodo'];
            $id_anhos_tipter = $record_tipper[0]['id_anhos_tipter'];
            $id_meses_tipter = $record_tipper[0]['id_meses_tipter'];
            $fecha_desde_tipter = $record_tipper[0]['fecha_desde_tipter'];
            $fecha_hasta_tipter = $record_tipper[0]['fecha_hasta_tipter'];

            /**
             * Incidente #10608 - 20181213
             */
            if ($definitivo == 1) {
                throw new Exception('El periodo a liquidar ya esta bloqueado.');
            }

            //Funcionario num_doc
            $num_doc = null;
            $whereFuncionarioNumDoc = "";
            if (isset($request['num_doc'])) {
                $num_doc = $request['num_doc'];
                $whereFuncionarioNumDoc = " AND tab0.num_doc = '" . $request['num_doc'] . "'";
            }
            //Funcionario id_tipo_doc 
            $id_tipo_doc = null;
            $whereFuncionarioTipoDoc = "";
            if (isset($request['id_tipo_doc'])) {
                $id_tipo_doc = $request['id_tipo_doc'];
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            }

            $sql = <<<EOD
SELECT * FROM NO_PERIODO WHERE ID_PERIODO = $id_periodo 
EOD;
            $results = CN_TABLE::executeSQL($sql);

            $id_tipo_periodo = $results[0]['id_tipo_periodo'];



//MemcacheHandler::getInstance()->set($progress_key, 100);
//exit();
            /*
             *  Borrar datos anteriores Periodo-Funcionario
             *  Borrar no_liquida_nomina el periodo de retroactivo para cada periodo de ajuste - 20130604
             */
            //Sql
            $sql = <<<EOD
delete from ( 
    select tab0.* from no_liquida_nomina tab0 
    join no_periodo per
    on tab0.id_periodo_ajuste = per.id_periodo
    where tab0.id_periodo = $id_periodo
    and (select id_anhos || lpad(id_meses,2,'0') from no_periodo where id_periodo = tab0.id_periodo_ajuste) >= (select id_anhos || lpad(id_meses,2,'0') from no_periodo where id_periodo = $id_periodo_ini)  
    and (select id_anhos || lpad(id_meses,2,'0') from no_periodo where id_periodo = tab0.id_periodo_ajuste) <= (select id_anhos || lpad(id_meses,2,'0') from no_periodo where id_periodo = $id_periodo_fin)
    and per.id_tipo_periodo = 5
    $whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
)
EOD;
            //Ejecutar SQL
            //Se deja quemado id-44 periodo de retroactivo inactivos INCI para no liquidar - 20130913
            if ($id_periodo != 44) {
                CN_TABLE::executeSQL($sql);
            }

//            MemcacheHandler::getInstance()->set($progress_key, 10);


            /*
             * Liquida el periodo nuevo de retroactivo
             */
            $sql = <<<EOD
select tab0.*
from no_periodo tab0 
where tab0.id_tipo_periodo = 5
and tab0.id_anhos || lpad(tab0.id_meses,2,'0') >= (select id_anhos || lpad(id_meses,2,'0') from no_periodo where id_periodo = $id_periodo_ini)  
and tab0.id_anhos || lpad(tab0.id_meses,2,'0') <= (select id_anhos || lpad(id_meses,2,'0') from no_periodo where id_periodo = $id_periodo_fin)
order by tab0.id_anhos , tab0.id_meses 
EOD;

            $results = CN_TABLE::executeSQL($sql);


            //COMMIT DE TODAS LAS TRANSACCIONES
            $this->conn->commit();

            /*
             * VALIDA LOS REGISTROS EN LA TABLA NO_ESTADO_FUNC
             * id 6 - tipo periodo retroactivo activos
             * id 7 - tipo periodo retroactivo inactivos
             */
            if ($id_tipo_periodo == 7) {

                /*
                 * Recorre los registros de funcionario - concepto nomina
                 * para ser liquidados
                 */
                $i = 1;
                $nom_conceptos_a_procesar = count($results);

                // Antes de inicar el proceso largo
                $brecha = 1;
                if ($nom_conceptos_a_procesar > 100)
                    $brecha = $nom_conceptos_a_procesar - (0.99 * $nom_conceptos_a_procesar);

                $this->logMessage("[Liquidación Retroactivo Def] nom_conceptos_a_procesar: " . $nom_conceptos_a_procesar);
                $logPath = sfConfig::get('sf_log_dir') . '/liquidacion.log';
                $custom_logger = new sfFileLogger(new sfEventDispatcher(), array('file' => $logPath));

                //For de liquidar por cada periodo entre el rango
                foreach ($results as $resul) {

                    // Guardar un valor en el proceso largo
                    if ($i % $brecha == 0) {
//                    MemcacheHandler::getInstance()->set($progress_key, round(($i / $nom_conceptos_a_procesar) * 100, 0));
                    }

                    $this->logMessage("[Liquidación Retroactivo Def] Existen liquidaciones.");


                    $id_periodo_ajuste = $resul['id_periodo'];
                    //Se deja quemado id-44 periodo de retroactivo inactivos INCI para no liquidar - 20130913
                    if ($id_periodo != 44) {
                        //llamar para cada periodo y liquidar
                        $this->liquidarRetroactivo($id_periodo, $id_periodo_ajuste, $progress_key, $record_consulta, $arrayConstantes, $whereFuncionarioNumDoc, $whereFuncionarioTipoDoc, $id_periodo_actual, $id_periodo_ini, $id_periodo_fin);
//MemcacheHandler::getInstance()->set($progress_key, 100);
//exit();
                    }
                    $i++;


                    /*
                     * Abrir conexion transaccion
                     */
                    $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                    $this->conn->beginTransaction();

                    /**
                     * Se coloca que para los ajustes de aplicar_liq_concep - 20230727::LAVILA
                     */
                    //Sql
                    $sql = <<<EOD
select 
tab0.id_tipo_doc,
tab0.num_doc,
tab0.id_concep_nomina,
tab0.id_periodo,
tab0.valor_ajuste,
 to_date( '01/' || per.id_meses || '/' || per.id_anhos, 'dd/mm/yyyy')  as fecha_desde,
TRUNC(LAST_DAY( to_date(per.id_meses || '/' || per.id_anhos, 'mm/yyyy')  )) as fecha_hasta,
tab0.num_dias,
nvl(tab0.valor_base,0) as valor_base,
tab0.id_periodo_ajuste    
                    
from no_ajuste_nomina tab0
join no_periodo per
on per.id_periodo = tab0.id_periodo 

WHERE 
tab0.aplicar_liq_concep = 1                     
and tab0.id_periodo = $id_periodo 
and tab0.id_periodo_ajuste = $id_periodo_ajuste 
$whereFuncionarioNumDoc    
EOD;

                    //Ejecutar SQL
                    $record_ajuste_liq = CN_TABLE::executeSQL($sql);

                    foreach ($record_ajuste_liq as $value_liq) {

                        $id_tipo_doc_ajus = $value_liq['id_tipo_doc'];
                        $num_doc_ajus = $value_liq['num_doc'];
                        $id_concep_nomina_ajus = $value_liq['id_concep_nomina'];
                        $id_periodo_ajus = $value_liq['id_periodo'];
                        $valor_ajuste_ajus = $value_liq['valor_ajuste'];
                        $num_dias_ajus = $value_liq['num_dias'];
                        $valor_base_ajus = $value_liq['valor_base'];
                        $id_periodo_ajuste_ajus = $value_liq['id_periodo_ajuste'];

                        //Actualizar cada funcionario-concepto de la liquidacion                
                        $sql = <<<EOD
update no_liquida_nomina set valor_liquidado = valor_liquidado + $valor_ajuste_ajus, 
    num_dias = num_dias + $num_dias_ajus, 
    valor_base = valor_base + ($valor_base_ajus) 
where 
num_doc = '$num_doc_ajus'
and id_concep_nomina = $id_concep_nomina_ajus 
and id_periodo = $id_periodo_ajus 
and id_tipo_doc = $id_tipo_doc_ajus 
and id_periodo_ajuste = $id_periodo_ajuste_ajus 
EOD;
                        //Ejecutar SQL
                        $this->conn->execute($sql);
                    }
                    $this->logMessage("[Liquidación Retroactivo] Ajuste nuevo de APLICAR_LIQ_CONCEP.");

                    //COMMIT DE TODAS LAS TRANSACCIONES
                    $this->conn->commit();
//                break;
                }
            }
//            MemcacheHandler::getInstance()->set($progress_key, 90);


            /*
             * Abrir conexion transaccion
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            //COMMIT DE TODAS LAS TRANSACCIONES
            $this->conn->commit();
//            MemcacheHandler::getInstance()->set($progress_key, 100);

            $records = array();

            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = $records;
            $this->logMessage("[Liquidación Retroactivo Def] Liquidación exitosa.");
        } catch (Exception $e) {
//            MemcacheHandler::getInstance()->set($progress_key, 99);
            //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
            $this->conn->rollback();
//            MemcacheHandler::getInstance()->set($progress_key, 100);

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->mensajeError = "[Liquidación Retroactivo Def] Ocurrio un error: " . $e->getMessage();
            $this->list_data = array();
            $this->logMessage("[Liquidación Retroactivo Def] ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * 
     * @param type $id_periodo
     * @param type $id_periodo_ajuste
     * @param type $progress_key
     * @param type $record_consulta
     * @param type $arrayConstantes
     * @param type $whereFuncionarioNumDoc
     * @param type $whereFuncionarioTipoDoc
     */
    public function liquidarRetroactivo($id_periodo, $id_periodo_ajuste, $progress_key, $record_consulta, $arrayConstantes, $whereFuncionarioNumDoc, $whereFuncionarioTipoDoc, $id_periodo_actual, $id_periodo_ini, $id_periodo_fin) {
        $this->logMessage("[Liquidación Retroactivo Def] Entro a liquidarRetroactivo");

        $i = 0;

        /**
         * Manejador de errores
         */
        try {


            /*
             * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7, CEV-8, CEV_PUB-9)
             */
            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

            $int = 0;
            foreach ($array as $routeName => $routeData) {
                //echo $routeName . "\n";
                if ('entidad_cliente' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $entidadCliente = $value;
                        }
                    }
                }
                $int++;
            }


            /**
             * Consultar salario minimo
             */
            $salario_minimo = 550000;
            //Sql
            $sql = <<<EOD
(select nvl(valor_mensual, 0) as valor_mensual from no_smdlv where vigencia = extract(year from sysdate))  
EOD;
            //Ejecutar SQL
            $record_smlv = CN_TABLE::executeSQL($sql);

            if (count($record_smlv) > 0) {
                //No se debe redondear - 20130802
//                $salario_minimo = round($record_smlv[0]['valor_mensual'], -3);
                $salario_minimo = round($record_smlv[0]['valor_mensual']);
            }


            /*
             * Abrir conexion transaccion
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /*
             * Tomar valores de NO_AJUSTE_NOMINA
             */
            //Sql
            $sql = <<<EOD
Insert into NO_LIQUIDA_NOMINA (ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,ID_PERIODO,VALOR_LIQUIDADO,FECHA_DESDE,FECHA_HASTA,NUM_DIAS,ID_PERIODO_AJUSTE) 

select 
tab0.id_tipo_doc,
tab0.num_doc,
tab0.id_concep_nomina,
tab0.id_periodo,
tab0.valor_ajuste,
 to_date( '01/' || per.id_meses || '/' || per.id_anhos, 'dd/mm/yyyy')  as fecha_desde,
TRUNC(LAST_DAY( to_date(per.id_meses || '/' || per.id_anhos, 'mm/yyyy')  )) as fecha_hasta,
tab0.num_dias,
tab0.ID_PERIODO_AJUSTE
from no_ajuste_nomina tab0
join no_periodo per
on per.id_periodo = tab0.id_periodo 
WHERE tab0.id_periodo = $id_periodo
and tab0.APLICAR_LIQ_CONCEP = 0       
and tab0.id_periodo_ajuste = $id_periodo_ajuste 
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
EOD;
            //Ejecutar SQL
            CN_TABLE::executeSQL($sql);

            /**
             * Funcionarios con novedad de retiro en el mes del periodo filtrado
             * Verificar que el funcionario este en no_estado_func_v para el periodo - 20150619
             * Verificar que el funcionario este en no_liquida_nomina para el periodo de definitiva - 20150623
             */
            //Sql
            $sql = <<<EOD
select
per.id_anhos as vig_ini,
1 as per_ini,
extract(YEAR FROM nom.fecha_retiro) as vig_fin,
extract(MONTH FROM nom.fecha_retiro) as per_fin, 
tab0.*,
nom.fecha_ingreso,
nom.fecha_termina,
nom.fecha_retiro,
per.id_anhos,
per.id_meses,
per.id_anhos || '-01-01' as fecha_ini,
case when 7 >= per.id_meses
then per.id_anhos - 1 else per.id_anhos end  as anho_ini
                    
from no_novedad_personal tab0

join no_novedades novs
on novs.id_novedad = tab0.id_novedad

join no_tipo_novedad tipnov
on tipnov.id_tipo_novedad = novs.id_tipo_novedad

join no_periodo per
on per.id_periodo = tab0.id_periodo

left join no_nombramiento_v nom
on tab0.num_doc = nom.num_doc
and tab0.id_tipo_doc = nom.id_tipo_doc
--and nom.estado = 1

where 
tipnov.id_tipo_novedad = 2
and per.id_meses = (select id_meses from no_periodo where id_periodo = $id_periodo_ajuste)   
and per.id_anhos = (select id_anhos from no_periodo where id_periodo = $id_periodo_ajuste) 
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
and tab0.num_doc in ( select distinct num_doc from no_estado_func_v where periodo = $id_periodo )
and tab0.num_doc in ( select distinct num_doc from no_liquida_nomina where id_periodo = $id_periodo_ajuste )
and tab0.estado = 1

and (nom.estado = 1 or
  ( nom.estado = 0 
    and (nom.fecha_retiro
  between to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo_ajuste) ,'dd/mm/yyyy')
  and trunc(last_day( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo_actual) ,'dd/mm/yyyy') ))
  or nom.fecha_retiro = trunc(last_day( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo_ajuste) ,'dd/mm/yyyy') )) + 1 )
  )
)
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);

            //Validar si hay funcionarios para liquidación
            if (count($records) > 0) {
                $this->logMessage("[Liquidación Retroactivo Def] Validar si hay funcionarios para liquidación.");

                $id_agrup_concepto = 93;

                /*
                 * Obtener concep_periodo por agrupacion - Orden a liquidar
                 */
                $sql = <<<EOD
select 
* 
from no_agrup_deta
where id_agrup_concepto = nvl((SELECT ID_AGRUP_CESDEF FROM NO_PARAM_CONCEP where ID_PARAM_CONCEP = 1),$id_agrup_concepto)
order by 
orden,
id_agrup_deta 
EOD;
                /*
                  $sql = <<<EOD
                  select distinct
                  tab0.id_concep_nomina,
                  'O' as tipo_valor
                  from no_liquida_nomina tab0

                  join no_periodo per
                  on tab0.id_periodo = per.id_periodo
                  where
                  (select id_anhos || lpad(id_meses,2,'0') from no_periodo where id_periodo = tab0.id_periodo) >= (select id_anhos || lpad(id_meses,2,'0') from no_periodo where id_periodo = $id_periodo_ini)
                  and (select id_anhos || lpad(id_meses,2,'0') from no_periodo where id_periodo = tab0.id_periodo) <= (select id_anhos || lpad(id_meses,2,'0') from no_periodo where id_periodo = $id_periodo_fin)
                  and per.id_tipo_periodo = 5
                  EOD;
                 */          //Ejecutar SQL
                $records_agrup = CN_TABLE::executeSQL($sql);


                /*
                 * Por funcionario 
                 */
                $i = 1;
                $nom_conceptos_a_procesar = count($records);

                // Antes de inicar el proceso largo
                $brecha = 1;
                if ($nom_conceptos_a_procesar > 100)
                    $brecha = $nom_conceptos_a_procesar - (0.99 * $nom_conceptos_a_procesar);

                $this->logMessage("[Liquidación Retroactivo Def] nom_conceptos_a_procesar: " . $nom_conceptos_a_procesar);
                foreach ($records as $value) {

                    // Guardar un valor en el proceso largo
                    if ($i % $brecha == 0) {
                        MemcacheHandler::getInstance()->set($progress_key, round(($i / $nom_conceptos_a_procesar) * 100, 0));
                    }

                    $this->logMessage("[Liquidación Retroactivo Def] Existen liquidaciones.");

                    /*
                     * Datos por record
                     */
                    $num_doc = $value['num_doc'];
                    $id_tipo_doc = $value['id_tipo_doc'];
                    $fecha_ingreso = $value['fecha_ingreso'];
                    $fecha_termina = $value['fecha_termina'];
                    $fecha_retiro = $value['fecha_retiro'];
                    $vig_ini = $value['vig_ini'];
                    $per_ini = $value['per_ini'];
                    $vig_fin = $value['vig_fin'];
                    $per_fin = $value['per_fin'];

                    /*
                     * Calcular los meses a liquidar
                     */
//                    $meses_liq = 0;

                    $anho_ini = $value['id_anhos'];
                    $fecha_ini = $anho_ini . '-07-01';
                    $anho_fin = $anho_ini + 1;
                    $fecha_fin = $anho_fin . '-07-01';
                    $meses_liq_orig = $meses_liq = $this->mesesLiquidar($id_periodo_ajuste, $num_doc, $id_tipo_doc, $fecha_ingreso, $fecha_termina, $value, $fecha_ini, $fecha_fin);
                    $this->logMessage("[Liquidación Retroactivo Def] Meses de Liquidación: " . $meses_liq);

                    /**
                     * Recorrer Agrupaciones
                     */
                    foreach ($records_agrup as $value_agrup) {

                        /*
                         * Variables agrup_concep
                         */
                        $id_concep_nomina = $value_agrup['id_concep_nomina'];
                        $caracter = $value_agrup['tipo_valor'];

                        /*
                         * Calcular los dias a liquidar
                         */
                        $dias_liq_array = $this->diasLiquidar($id_periodo_ajuste, $num_doc, $id_tipo_doc, $fecha_ingreso, $fecha_termina, $value, $id_concep_nomina);

                        //Si la formula aplica meses no busca dias en no_liquida_nomina - 20220422::LAVILA
                        $sql = <<<EOD
select
*
from no_formula
where
FORMULA like '%meses%'
and id_concep_nomina = $id_concep_nomina  
EOD;
                        //Ejecutar SQL
                        $records_for = CN_TABLE::executeSQL($sql);
                        if (count($records_for) == 0) {

                            /**
                             * Se cambia validacion para que tome dias de la liq_definitiva y si no tiene coloca 0, para forzar lo pagado en cada periodo que corresponda - 20211013::LAVILA
                             */
                            $sql = <<<EOD
SELECT
    *
FROM no_liquida_nomina
where
num_doc = '$num_doc'
and id_concep_nomina = $id_concep_nomina
and id_periodo = $id_periodo_ajuste
and num_dias > 0 
EOD;
                            //Ejecutar SQL
                            $recordsLiq_def = CN_TABLE::executeSQL($sql);

                            if (count($recordsLiq_def) > 0) {
                                $dias_liq_array['num_dias'] = $recordsLiq_def[0]['num_dias'];
                                $meses_liq = $recordsLiq_def[0]['num_dias'];
                            } else {
                                $dias_liq_array['num_dias'] = 0;
                                $meses_liq = 0;
                            }
                        } else {
                            $meses_liq = $meses_liq_orig;
                        }

                        $dias_liq = $dias_liq_array['num_dias'];
                        $dias_liq_base = $dias_liq_array['num_dias_base'];
                        $dias_otra_ent = $dias_liq_array['dias_otra_entidad'];

                        $this->logMessage("[Liquidación Retroactivo Def] Dias de Liquidación: " . $dias_liq);

                        /**
                         * Tag_retro para cuando es retroactivo, para retencion tiene encuenta todo el mes con lo del retroactivo - 20150610
                         * Se cambia datos fin($vig_fin  y $per_fin) del retiro por el periodo del retro - 20150701
                         * Se agrega valor_uvt, valor_bonif - 20170613
                         * Segun entidad toma LIQUIDACION DEFINITIVA, liquide la Retefuente solo con los pagos de este periodo, sin tener en cuenta las otras nóminas.
                         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7, CEV-8, CEV_PUB-9) - 20200624::LAVILA
                         * Se agrega CEV en case de entidad - 20200917
                         * Se agrega SGC en case de entidad - 20210407
                         */
                        $sql = <<<EOD
select
nvl((select valor_uvt from ts_uvt where vigencia = (select no_periodo.id_anhos from no_periodo where id_periodo = $id_periodo)) , 1) as valor_uvt,  
nvl((select valor_fijo from no_concep_ab where id_concep_nomina in (select no_param_concep.id_concep_bonif from no_param_concep where no_param_concep.id_param_concep = 1)) , 1) as valor_bonif,                                
case when $entidadCliente in (1,5,8,9) and $id_concep_nomina = (select no_param_concep.id_concep_rete from no_param_concep where no_param_concep.id_param_concep = 1) then 1 else 0 end as tag_def,
0 as tag_def,
$salario_minimo as salario_minimo,
0 as tag,
1 as tg_retro,
nvl((select valor_uvt from ts_uvt where vigencia = (select no_periodo.id_anhos from no_periodo where id_periodo = $id_periodo)) , 1) as valor_uvt,
nvl((select valor_fijo from no_concep_ab where id_concep_nomina in (select no_param_concep.id_concep_bonif from no_param_concep where no_param_concep.id_param_concep = 1)) , 1) as valor_bonif, 
0 as promedio,
$vig_ini as vig_ini,
$per_ini as per_ini,
(select id_anhos from no_periodo where id_periodo = $id_periodo) as vig_fin,
(select id_meses from no_periodo where id_periodo = $id_periodo) as per_fin,
$meses_liq as meses_liq,
$dias_liq as dias_liq,
$dias_otra_ent as dias_otra_ent,
0 as dias_ausenc,
'$caracter' as caracter,
nvl('$fecha_ingreso', '') as fecha_ingreso,
nvl('$fecha_termina', '') as fecha_termina,
nvl('$fecha_retiro', '') as fecha_retiro,
$dias_liq as num_dias,
$dias_liq_base as num_dias_base,
null as porcentaje,
$num_doc as num_doc,
$id_tipo_doc as id_tipo_doc,
$id_periodo as id_periodo,
$id_periodo as periodo,
$id_concep_nomina as id_concep_nomina,
0 as valor,
(select usa_dias_calen from no_concep_nomina where id_concep_nomina = $id_concep_nomina) as usa_dias_calen 
from dual     
EOD;
                        //Ejecutar SQL
                        $recordsLiq = CN_TABLE::executeSQL($sql);

                        /*
                         * Validar registro
                         */
                        if (count($recordsLiq) > 0) {

                            //Liquidar concepto
                            $record_liq = $recordsLiq[0];
                            $this->liquidar($id_periodo, $num_doc, $id_tipo_doc, $id_concep_nomina, $record_liq, $arrayConstantes, $id_periodo_ajuste);
                        } else {
                            /*
                             * Mensaje de error
                             */
                            $mensajeError = "No hay registro para liquidación definitiva. Concepto: " . $id_concep_nomina;

//                            $this->status = 1;
//                            $this->list_data = array();
//                            $this->mensajeError = $mensajeError;
                            $this->logMessage("[Liquidación Retroactivo Def] " . $mensajeError);
                        }
                    }
//                    die();
                    $i++;


                    /**
                     * INICIO :: Calculo Salud / Pension Liq Def - 20141014
                     */
                    $this->logMessage("[Liquidación Retroactivo Def] Calculo Salud / Pension Liq Def");

                    /*
                     * Traer conceptos por funcionario de salud / pension
                     */
                    $sql = <<<EOD
select distinct
desdet.porcentaje_func,
desdet.porcentaje_patrono,
foncon.id_descuento_ss,
foncon.id_concep_nomina,
afifon.* 
from no_afilia_fondo afifon

join no_fondo_concepto foncon
on foncon.id_mae_fondos = afifon.id_mae_fondos

join no_descto_detalle desdet
on desdet.id_tipo_aporte = afifon.id_tipo_aporte
and foncon.id_descuento_ss = desdet.id_descuento_ss

where
afifon.NUM_DOC = $num_doc
and afifon.estado = 1
and afifon.id_clase_fondo in (1,2)

order by
afifon.id_clase_fondo     
EOD;
                    //Ejecutar SQL
                    $recordsFondo = CN_TABLE::executeSQL($sql);

                    /**
                     * Recorrer Agrupaciones
                     */
                    foreach ($recordsFondo as $valueFondo) {

                        /*
                         * Variables agrup_concep
                         */
                        $id_concep_nomina = $valueFondo['id_concep_nomina'];
                        $porcentaje = $valueFondo['porcentaje_func'];
                        $caracter = "T";


                        /*
                         * Tag_retro para cuando es retroactivo, para retencion tiene encuenta todo el mes con lo del retroactivo - 20150610
                         * Se agrega valor_uvt, valor_bonif - 20170613
                         */
                        $sql = <<<EOD
select
1 as tag_def,
$salario_minimo as salario_minimo,
0 as tag,
0 as tg_retro,
nvl((select valor_uvt from ts_uvt where vigencia = (select no_periodo.id_anhos from no_periodo where id_periodo = $id_periodo)) , 1) as valor_uvt,
nvl((select valor_fijo from no_concep_ab where id_concep_nomina in (select no_param_concep.id_concep_bonif from no_param_concep where no_param_concep.id_param_concep = 1)) , 1) as valor_bonif, 
0 as promedio,
$vig_ini as vig_ini,
$per_ini as per_ini,
$vig_fin as vig_fin,
$per_fin as per_fin,
$meses_liq as meses_liq,
30 as dias_liq,
0 as wdiasv,
$dias_otra_ent as dias_otra_ent,
0 as dias_ausenc,
'$caracter' as caracter,
nvl('$fecha_ingreso', '') as fecha_ingreso,
nvl('$fecha_termina', '') as fecha_termina,
nvl('$fecha_retiro', '') as fecha_retiro,
30 as num_dias,
$dias_liq_base as num_dias_base,
$porcentaje as porcentaje,
$num_doc as num_doc,
$id_tipo_doc as id_tipo_doc,
$id_periodo_ajuste as id_periodo_ajuste,
$id_periodo as id_periodo,
$id_periodo as periodo,
$id_concep_nomina as id_concep_nomina,
0 as valor,
(select usa_dias_calen from no_concep_nomina where id_concep_nomina = $id_concep_nomina) as usa_dias_calen 
from dual     
EOD;
                        //Ejecutar SQL
                        $records = CN_TABLE::executeSQL($sql);

                        /*
                         * Recorre los registros de funcionario - concepto nomina
                         * para ser liquidados
                         */
                        foreach ($records as $value) {
                            $this->logMessage("[Liquidación Retroactivo Def] Existen liquidaciones.");

                            $id_periodo = $value['periodo'];
                            $num_doc = $value['num_doc'];
                            $id_tipo_doc = $value['id_tipo_doc'];
                            $id_concep_nomina = $value['id_concep_nomina'];

                            /*
                             * Liquidar periodo-funcionario-concepto nomina
                             */
                            $this->liquidar($id_periodo, $num_doc, $id_tipo_doc, $id_concep_nomina, $value, $arrayConstantes, $id_periodo_ajuste);
                        }
                    }

                    $this->logMessage("[Liquidación Retroactivo Def] Existen liquidaciones. FSP");

                    /*
                     * FSP - 20141014
                     */
                    $valor_base = 0;


                    /*
                     * Tag_retro para cuando es retroactivo, para retencion tiene encuenta todo el mes con lo del retroactivo - 20150610
                     * Se agrega valor_uvt, valor_bonif - 20170613
                     */
                    //Sql
                    $sql = <<<EOD
select 
$salario_minimo as salario_minimo,
0 as tag,
0 as tg_retro,
nvl((select valor_uvt from ts_uvt where vigencia = (select no_periodo.id_anhos from no_periodo where id_periodo = $id_periodo)) , 1) as valor_uvt,
nvl((select valor_fijo from no_concep_ab where id_concep_nomina in (select no_param_concep.id_concep_bonif from no_param_concep where no_param_concep.id_param_concep = 1)) , 1) as valor_bonif,
$id_periodo_ajuste as id_periodo_ajuste,
$id_periodo as periodo,                    
tab0.* 
from no_liquida_nomina tab0
left join no_fondo_concepto foncon
on tab0.id_concep_nomina = foncon.id_concep_nomina
where foncon.id_descuento_ss = 2
and tab0.id_periodo = $id_periodo
and tab0.id_periodo_ajuste = $id_periodo_ajuste   
and tab0.num_doc = $num_doc
order by 
tab0.id_tipo_doc,
tab0.num_doc
EOD;

                    //Ejecutar SQL
                    $record_fsp = CN_TABLE::executeSQL($sql);

                    foreach ($record_fsp as $value) {

                        $id_liquida_nomina = $value['id_liquida_nomina'];
                        $valor_base = $value['valor_liquidado'];
                        $valor_base_vac = 0;
                        $num_doc = $value['num_doc'];
                        $id_tipo_doc = $value['id_tipo_doc'];
                        $num_dias_fsp = $value['num_dias'];
                        $id_concep_nomina = $value['id_concep_nomina'];

                        $this->logMessage("[Liquidación Retroactivo Def] FSP. num_doc:" . $num_doc . " - id_concep_nomina:" . $id_concep_nomina);


                        /*
                         * Valor vase formula FSP
                         */
                        $valor_base = round($valor_base, -3);
                        //                $valor_base = round($valor_base);
                        //valor base no puede superar 25 salarios minimos
                        if ($valor_base > ($salario_minimo * 25)) {
                            $valor_base = round(($salario_minimo * 25) - 1, -3);
                            //                    $valor_base = round(($salario_minimo * 25) - 1);
                        }

                        $dias_liq = 30;
                        $wdiasv_tot = 0;



                        //Sql
                        $sql = <<<EOD
select nvl(sum(valor),0) as valor from no_concepto_func 
    where num_doc = $num_doc and id_tipo_doc = 1 
        and id_concep_nomina = (select no_param_concep.id_concep_basica from no_param_concep where no_param_concep.id_param_concep = 1) 
            and estado = 1 and actual = 1 
EOD;

                        //Ejecutar SQL
                        $record_asig = CN_TABLE::executeSQL($sql);

                        $this->logMessage("[Liquidación Retroactivo Def] FSP. Entro");

                        $salario = $record_asig[0]['valor'];

                        //Anexo dias totales y de vacaciones totales - 20131217
                        $array_valor_base = $this->valor_base_fsp($valor_base, $salario_minimo, $valor_base_vac, $wdiasv_tot, $dias_liq, $num_doc, $id_periodo, $salario);
                        $valor_fsp = $array_valor_base['valor_fsp'];
                        $porcentaje_fsp = $array_valor_base['porcentaje_fsp'];

                        /**
                         * SQL de consulta para validar si el concepto de FSP es por ajuste - 20131129
                         */
                        //Sql
                        $sql = <<<EOD
select 
tab0.id_tipo_doc,
tab0.num_doc,
tab0.id_concep_nomina,
tab0.id_periodo,
tab0.valor_ajuste,
 to_date( '01/' || per.id_meses || '/' || per.id_anhos, 'dd/mm/yyyy')  as fecha_desde,
TRUNC(LAST_DAY( to_date(per.id_meses || '/' || per.id_anhos, 'mm/yyyy')  )) as fecha_hasta,
tab0.num_dias,
tab0.porcentaje
from no_ajuste_nomina tab0
join no_periodo per
on per.id_periodo = tab0.id_periodo 
WHERE tab0.id_periodo = $id_periodo 
and tab0.APLICAR_LIQ_CONCEP = 0
and tab0.NUM_DOC = $num_doc
and tab0.id_concep_nomina = $id_concep_nomina
EOD;

                        //Ejecutar SQL
                        $record_fsp_ver = CN_TABLE::executeSQL($sql);

                        /*
                         * Validar si el FSP es por ajuste - 20131129
                         */
                        if (count($record_fsp_ver) == 0) {

                            if ($valor_fsp > 0) {

                                /*
                                 * Actualizar valores de FSP
                                 */
                                //sentencia sql
                                $sql = <<<EOD
update NO_LIQUIDA_NOMINA set valor_liquidado =  $valor_fsp
        , porcentaje = $porcentaje_fsp
            , valor_base = round( valor_liquidado, -3 ) 
    where id_liquida_nomina = $id_liquida_nomina 
        and id_periodo = $id_periodo
EOD;
                                //ejecuta y obtiene el resultado del sql
                                CN_TABLE::executeSQL($sql);
                            } else {

                                /*
                                 * Borrar del FSP
                                 */
                                //sentencia sql
                                $sql = <<<EOD
delete from NO_LIQUIDA_NOMINA where id_liquida_nomina = $id_liquida_nomina 
and id_periodo = $id_periodo
EOD;
                                //ejecuta y obtiene el resultado del sql
                                CN_TABLE::executeSQL($sql);
                            }
                        } else {

                            $valor_ajuste = $record_fsp_ver[0]["valor_ajuste"];

                            /*
                             * Borrar del FSP que no estan en la tabla de ajustes - 20140515
                             */
                            //sentencia sql
                            $sql = <<<EOD
delete from NO_LIQUIDA_NOMINA where id_liquida_nomina = $id_liquida_nomina 
and id_periodo = $id_periodo
and valor_liquidado != $valor_ajuste
EOD;
                            //ejecuta y obtiene el resultado del sql
                            CN_TABLE::executeSQL($sql);
                        }
                    }


                    /**
                     * FIN :: Calculo Salud / Pension Liq Def
                     */
//                    die();


                    /*
                     * Solo retefunte
                     * Inicio del proceso de calculo de Retencion en la fuente concepto 2001
                     * Tag_retro para cuando es retroactivo, para retencion tiene encuenta todo el mes con lo del retroactivo - 20150610
                     * Se agrega valor_uvt, valor_bonif - 20170613
                     */
                    //Sql
                    $sql = <<<EOD
select
0 as tag_def,                            
1 as tag,
1 as tg_retro,
nvl((select valor_uvt from ts_uvt where vigencia = (select no_periodo.id_anhos from no_periodo where id_periodo = $id_periodo)) , 1) as valor_uvt,
nvl((select valor_fijo from no_concep_ab where id_concep_nomina in (select no_param_concep.id_concep_bonif from no_param_concep where no_param_concep.id_param_concep = 1)) , 1) as valor_bonif,
0 as meses_liq,
'O' as caracter, 
0 as num_dias, 
0 as num_dias_base,
0 as dias_liq,
$id_periodo as id_periodo,
$id_periodo as periodo,
tab0.*, 
tab0.fecha_desde as fecha_ingreso,
tab0.fecha_hasta as fecha_termina,
tab0.fecha_hasta as fecha_retiro,
connom.usa_dias_calen
from no_concepto_func tab0
join no_concep_nomina connom
on connom.id_concep_nomina = tab0.id_concep_nomina                            
WHERE 1 = 1 
AND tab0.num_doc = '$num_doc'
AND tab0.id_tipo_doc = $id_tipo_doc 
and tab0.id_concep_nomina = (select id_concep_rete from no_param_concep where id_param_concep = 1)
and tab0.estado = 0
and tab0.actual = 1
order by 
tab0.id_tipo_doc,
tab0.num_doc 
EOD;
                    //Ejecutar SQL
                    $records = CN_TABLE::executeSQL($sql);


                    /*
                     * Recorre los registros de funcionario - concepto nomina
                     * para ser liquidados
                     */
                    foreach ($records as $value) {
                        $this->logMessage("[Liquidación Retroactivo Def] Existen liquidaciones.");

                        $id_periodo = $value['periodo'];
                        $num_doc = $value['num_doc'];
                        $id_tipo_doc = $value['id_tipo_doc'];
                        $id_concep_nomina = $value['id_concep_nomina'];

                        /*
                         * Liquidar periodo-funcionario-concepto nomina
                         */
                        $this->liquidar($id_periodo, $num_doc, $id_tipo_doc, $id_concep_nomina, $value, $arrayConstantes, $id_periodo_ajuste);
                    }
                }

                $this->logMessage("[Liquidación Retroactivo Def] Memcache al 90 porciento");

                //commit de las transacciones
                $this->conn->commit();

                /*
                 * Abrir conexion transaccion
                 */
                $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                $this->conn->beginTransaction();

                //Traer las diferecias de liquida nomina para rango de periodos
                /*
                 * se quita agrupacion de fechas para tener encuenta todos los registros por usuario y concepto - 20140520
                 */
                $sql = <<<EOD

select ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,$id_periodo AS ID_PERIODO,
   DIFERENCIA AS VALOR_LIQUIDADO,
       FECHA_DESDE,FECHA_HASTA,NUM_DIAS,ID_PERIODO_AJUSTE

FROM(

select ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,FECHA_DESDE,FECHA_HASTA,NUM_DIAS,ID_PERIODO_AJUSTE,VALOR,VALOR_LIQUIDADO,(VALOR - VALOR_LIQUIDADO) AS DIFERENCIA

FROM(

select tab0.*,nvl(tab1.valor_liquidado,0) AS VALOR_LIQUIDADO


from(

select tab0.ID_TIPO_DOC,tab0.NUM_DOC,tab0.ID_CONCEP_NOMINA,
min(tab0.FECHA_DESDE) as FECHA_DESDE, min(tab0.FECHA_HASTA) as FECHA_HASTA,
sum(tab0.NUM_DIAS)AS NUM_DIAS,tab0.ID_PERIODO_AJUSTE,sum(nvl(tab0.VALOR_LIQUIDADO,0)) AS VALOR
                        
from no_liquida_nomina tab0

where tab0.id_periodo = $id_periodo  and tab0.id_periodo_ajuste = $id_periodo_ajuste 

group by tab0.ID_TIPO_DOC,tab0.NUM_DOC,tab0.ID_CONCEP_NOMINA,
--tab0.FECHA_DESDE,tab0.FECHA_HASTA,
tab0.ID_PERIODO_AJUSTE

order by tab0.ID_PERIODO_AJUSTE,tab0.ID_TIPO_DOC,tab0.NUM_DOC,tab0.ID_CONCEP_NOMINA

)tab0                 

left join 
(select tab1.ID_TIPO_DOC,tab1.NUM_DOC,tab1.ID_CONCEP_NOMINA,tab1.ID_PERIODO,sum(nvl(tab1.VALOR_LIQUIDADO,0)) AS VALOR_LIQUIDADO
from no_liquida_nomina tab1
group by tab1.id_tipo_doc,tab1.num_doc,tab1.id_concep_nomina,tab1.id_periodo               
)tab1 ON tab1.id_tipo_doc = tab0.id_tipo_doc and tab1.num_doc = tab0.num_doc and tab1.id_concep_nomina = tab0.id_concep_nomina and tab0.id_periodo_ajuste = tab1.id_periodo

where tab0.num_doc IS NOT NULL 
AND tab0.ID_CONCEP_NOMINA!=(select tab2.id_concep_nomina from no_param_concep tab1 
left join no_concep_nomina tab2 ON tab2.id_concep_nomina = tab1.id_concep_rete) 
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc    
)

)
               
EOD;
                //ejecuta y obtiene el resultado del sql
                $results = CN_TABLE::executeSQL($sql);

                /*
                 * Memcache
                 */
                $i = 1;
                $nom_conceptos_a_procesar = count($results);

                // Antes de inicar el proceso largo
                $brecha = 1;
                if ($nom_conceptos_a_procesar > 100)
                    $brecha = $nom_conceptos_a_procesar - (0.99 * $nom_conceptos_a_procesar);

                $this->logMessage("[Liquidación Retroactivo Def] Liquidar diferencias de definitivas.");

                foreach ($results as $resul) {

                    // Guardar un valor en el proceso largo
                    if ($i % $brecha == 0) {
                        $por = round(($i / $nom_conceptos_a_procesar) * 100, 0);
                        //MemcacheHandler::getInstance()->set($progress_key, 90 + ($por / 10));
                    }

                    $i++;

                    $id_periodo = $resul['id_periodo'];
                    $id_tipo_doc = $resul['id_tipo_doc'];
                    $num_doc = $resul['num_doc'];
                    $id_concep_nomina = $resul['id_concep_nomina'];
                    $valor = $resul['valor_liquidado'];
                    $fecha_desde = $resul['fecha_desde'];
                    $fecha_desde = explode(' ', $fecha_desde);
                    $fecha_desde = $fecha_desde[0];
                    $fecha_hasta = $resul['fecha_hasta'];
                    $fecha_hasta = explode(' ', $fecha_hasta);
                    $fecha_hasta = $fecha_hasta[0];
                    $num_dias = 'null';
                    if (!is_null($resul['num_dias'])) {
                        $num_dias = $resul['num_dias'];
                    }
                    $id_periodo_ajuste = $resul['id_periodo_ajuste'];

                    $sql = <<<EOD
DELETE FROM NO_LIQUIDA_NOMINA tab0 
    where tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc  
    and tab0.id_concep_nomina = $id_concep_nomina 
    and tab0.id_periodo_ajuste =  $id_periodo_ajuste and tab0.id_periodo = $id_periodo
EOD;
                    //ejecuta y obtiene el resultado del sql
                    CN_TABLE::executeSQL($sql);

                    /*
                     * Se trae el id de concepto nomina si tiene id de ajuste
                     */
                    $sql = <<<EOD
select case when tab0.id_concep_ajuste is null then tab0.id_concep_nomina 
    else tab0.id_concep_ajuste end as id_concep_nomina
from no_concep_nomina tab0    
where tab0.id_concep_nomina = $id_concep_nomina   
EOD;

                    $results = CN_TABLE::executeSQL($sql);

                    $id_concep_nomina = $results[0]['id_concep_nomina'];

                    //Validar registros mayores a cero
                    if ($valor != 0) {
                        //Crea el nuevo registro en liquida nomina con la diferencia del valor y id de retroactivo
                        $sql = <<<EOD
INSERT INTO NO_LIQUIDA_NOMINA (ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,ID_PERIODO,VALOR_LIQUIDADO,FECHA_DESDE,FECHA_HASTA,NUM_DIAS,ID_PERIODO_AJUSTE) 
             VALUES($id_tipo_doc,$num_doc,$id_concep_nomina,$id_periodo,$valor,TO_DATE('$fecha_desde','YYYY-MM-DD'),TO_DATE('$fecha_hasta','YYYY-MM-DD'),
             $num_dias,$id_periodo_ajuste)
EOD;
                        //ejecuta y obtiene el resultado del sql
                        CN_TABLE::executeSQL($sql);
                    }
                }
                //MemcacheHandler::getInstance()->set($progress_key, 99);


                /*
                 * Memcache al 100 porciento
                 */
//                MemcacheHandler::getInstance()->set($progress_key, 100);
                //commit de las transacciones
                $this->conn->commit();
                $this->logMessage("[Liquidación Retroactivo Def] Memcache al 100 porciento");
            } else {
                //commit de las transacciones
                $this->conn->rollback();
            }
        } catch (Exception $exc) {
            $this->logMessage("[Liquidación Retroactivo Def] ERROR!!! liquidarRetroactivo");
            $this->conn->rollback();
        }
    }

    /**
     * Calcular los meses a liquidar
     * @param type $id_periodo
     * @param type $num_doc
     * @param type $id_tipo_doc
     * @param type $fecha_ingreso
     * @param type $fecha_termina
     * @param type $record
     */
    private function mesesLiquidar($id_periodo, $num_doc, $id_tipo_doc, $fecha_ingreso, $fecha_termina, $record, $fecha_ini, $fecha_fin) {
        /*
         * Variables de calculo
         */
        $meses = 0;
        $dias_otra_entidad = 0;
        $dias_otra_entidad_liq = 0;
        $dias_ausenc = 0;
        $meses_otra_entidad = 0;


        /**
         * Calculo dias certif otra entidad - 20140610
         */
        //Sql
        $sql = <<<EOD
select 
case when FECHA_DESDE < TO_DATE('$fecha_ini','yyyy-mm-dd') then TO_DATE('$fecha_ini','yyyy-mm-dd') else FECHA_DESDE end as FECHA_INI,
case when FECHA_HASTA > TO_DATE('$fecha_fin','yyyy-mm-dd') then TO_DATE('$fecha_fin','yyyy-mm-dd') else FECHA_HASTA end as FECHA_fin,
case when FECHA_HASTA > TO_DATE('$fecha_fin','yyyy-mm-dd') then TO_DATE('$fecha_fin','yyyy-mm-dd') else FECHA_HASTA end 
- 
case when FECHA_DESDE < TO_DATE('$fecha_ini','yyyy-mm-dd') then TO_DATE('$fecha_ini','yyyy-mm-dd') else FECHA_DESDE end as  DIAS, 

ID_CERTIF_OTRA_ENTIDAD,
ID_TIPO_DOC,
NUM_DOC,
NUM_DOC_SOP,
FECHA_SOPORTE,
OBSERVACIONES,
FECHA_DESDE,
FECHA_HASTA,
NUM_DIAS,
aplica_liquidacion

from NO_CERTIF_OTRA_ENTIDAD

where
(
    FECHA_DESDE between TO_DATE('$fecha_ini','yyyy-mm-dd') and TO_DATE('$fecha_fin','yyyy-mm-dd')
    or 
    FECHA_HASTA between to_date('$fecha_ini','yyyy-mm-dd') and to_date('$fecha_fin','yyyy-mm-dd')
)               
AND num_doc = '$num_doc'
AND id_tipo_doc = $id_tipo_doc
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        foreach ($records as $key => $value) {

            $fecha_ini_otra = $value['fecha_ini'];
            $fecha_fin_otra = $value['fecha_fin'];
            $aplica_liq = $value['aplica_liquidacion'];

            if ($aplica_liq == 1) {
                $dias_otra_entidad_liq += CN_TABLE::diasEntreFechas($fecha_ini_otra, $fecha_fin_otra, false);
            }
            $dias_otra_entidad += CN_TABLE::diasEntreFechas($fecha_ini_otra, $fecha_fin_otra, false);
        }

        $this->logMessage("[Liquidación Agrupación] Dias de otra entidad: " . $dias_otra_entidad);
        $meses_otra_entidad = ($dias_otra_entidad * 12) / 360;
        $this->logMessage("[Liquidación Agrupación] Meses de otra entidad: " . $meses_otra_entidad);



        /**
         * Recorrer cada mes desde el ingreso para verificar kardex
         * verificar ingreso y retiro -20140610
         */
        $anho_ini = $record['anho_ini'];
        $fecha_ini = $anho_ini . '-07-01';
        $date1 = new DateTime($fecha_ini);
        $date2 = new DateTime($fecha_ingreso);
        if ($date2 > $date1) {
            $fecha_ingreso_ka = $fecha_ingreso;
        } else {
            $fecha_ingreso_ka = $fecha_ini;
        }
        $fecha_termina_ka = $fecha_termina;

        //Dividir fecha formato yyyy-mm-dd
        $fecha_ingreso_ka = explode('-', $fecha_ingreso_ka);
        $fecha_termina_ka = explode('-', $fecha_termina_ka);

        $anho_mes_ini = $fecha_ingreso_ka[0] . str_pad($fecha_ingreso_ka[1], 2, '0', STR_PAD_LEFT);
        $anho_mes_fin = $fecha_termina_ka[0] . str_pad($fecha_termina_ka[1], 2, '0', STR_PAD_LEFT);

        $anho_mes_ini = $anho_mes_ini * 1;
        $anho_mes_fin = $anho_mes_fin * 1;
        $this->logMessage("[CN_TABLE] anho_mes_ini: " . $anho_mes_ini . ' - anho_mes_fin: ' . $anho_mes_fin);

        $dia_ini = $fecha_ingreso_ka[2];
        $mes_ini = $fecha_ingreso_ka[1];
        $anho_ini = $fecha_ingreso_ka[0];
        $dia_fin = $fecha_termina_ka[2];
        $mes_fin = $fecha_termina_ka[1];

        do {

            /*
             * Validar mes completo
             */
            if ($anho_mes_ini <= $anho_mes_fin && $dia_ini == 1) {
                $dias_ausenc = $dias_ausenc + $this->tieneNovKa($id_tipo_doc, $num_doc, $anho_ini, $mes_ini);
            }

            if ($anho_mes_ini > 220001) {
                $this->logMessage("[CN_TABLE] Supero mes 220001.");
                $dias_ausenc = 0;
                $anho_mes_ini = $anho_mes_fin + 1;
            }

            $fecha_ingreso_ka = CN_TABLE::fechaSiguiente(substr($anho_mes_ini, 0, 4), substr($anho_mes_ini, 4, 2));
            $anho_mes_ini = $fecha_ingreso_ka['id_anhos'] . str_pad($fecha_ingreso_ka['id_meses'], 2, '0', STR_PAD_LEFT);
            $anho_mes_ini = $anho_mes_ini * 1;
            $dia_ini = 1;

            $anho_ini = $fecha_ingreso_ka['id_anhos'];
            $mes_ini = $fecha_ingreso_ka['id_meses'];

            $this->logMessage("[CN_TABLE] anho_mes_ini: " . $anho_mes_ini);
        } while ($anho_mes_ini <= $anho_mes_fin);


        $this->logMessage("[Liquidación Agrupación] Dias de ausencias-meses: " . $dias_ausenc);



        /*
         * Prima servicios proporcional - Julio 1 anterior a la fecha de retiro y hasta la misma fecha de retiro
         */
        $anho_ini = $record['anho_ini'];
        $fecha_ini = $anho_ini . '-07-01';

        $date1 = new DateTime($fecha_ini);
        $date2 = new DateTime($fecha_ingreso);

        if ($date2 > $date1) {
            $meses = CN_TABLE::mesesEntreFechas($fecha_ingreso, $fecha_termina, false);
        } else {
            $meses = CN_TABLE::mesesEntreFechas($fecha_ini, $fecha_termina, false);
        }

        /**
         * Calculo de meses
         */
        $this->logMessage("[Liquidación Definitiva] Meses liquidacion: " . $meses);

        /**
         * return meses
         */
        return $meses + $meses_otra_entidad - $dias_ausenc;
    }

    /**
     * Calcular los meses a liquidar
     * @param type $id_periodo
     * @param type $num_doc
     * @param type $id_tipo_doc
     * @param type $fecha_ingreso
     * @param type $fecha_termina
     * @param type $record
     */
    private function mesesLiquidar2($id_periodo, $num_doc, $id_tipo_doc, $fecha_ingreso, $fecha_termina, $record) {
        /*
         * Variables de calculo
         */
        $meses = 0;

        /*
         * Prima servicios proporcional - Julio 1 anterior a la fecha de retiro y hasta la misma fecha de retiro
         */
        $anho_ini = $record['anho_ini'];
        $fecha_ini = $anho_ini . '-07-01';

        $date1 = new DateTime($fecha_ini);
        $date2 = new DateTime($fecha_ingreso);

        if ($date2 > $date1) {
            $meses = CN_TABLE::mesesEntreFechas($fecha_ingreso, $fecha_termina, false);
        } else {
            $meses = CN_TABLE::mesesEntreFechas($fecha_ini, $fecha_termina, false);
        }

        /**
         * Calculo de meses
         */
//        $this->logMessage("[Liquidación Retroactivo Def] Meses liquidacion: " . $meses);
        return $meses;
    }

    /**
     * Calcular los dias a liquidar (ausencias no afectan antiguedad) 
     * @param type $id_periodo
     * @param type $num_doc
     * @param type $id_tipo_doc
     * @param type $fecha_ingreso
     * @param type $fecha_termina
     * @param type $record
     * @param type $id_concep_nomina
     * @return int
     */
    private function diasLiquidar($id_periodo, $num_doc, $id_tipo_doc, $fecha_ingreso, $fecha_termina, $record, $id_concep_nomina) {

        /*
         * Variables de calculo
         */
        $dias = 0;
        $dias_base = 0;
        $dias_array = array();
        $dias_kardex = 0;
        $dias_vac = 0;
        $dias_otra_entidad = 0;
        $dias_otra_entidad_liq = 0;

        $fecha_ini_causa_vac = $fecha_ini_ka = $fecha_ingreso;
        $fecha_fin_ka = $fecha_termina;
        $fecha_retiro = $record['fecha_retiro'];

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }
            $int++;
        }

        /*
         * Calculo de dias por concepto
         */
        //Vacaciones proporcional - Tabla de causacion vacaciones
        if ($id_concep_nomina == 8 || $id_concep_nomina == 9 || $id_concep_nomina == 10) {
            /*
             * Calculo de dias de ausencias
             */
            //Sql
            $sql = <<<EOD
select * from no_causa_vacac  
where 
num_doc =  '$num_doc'  and  id_tipo_doc = $id_tipo_doc 
and to_date('$fecha_termina','yyyy-mm-dd') between fecha_ini and fecha_fin 
order by FECHA_INI desc 
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);

            if (count($records) > 0) {

                //Consulta para dias de otros periodos de vacaciones no tomados - 20130620
                $id_causa_vacac = $records[0]['id_causa_vacac'];

                //Sql
                $sql = <<<EOD
select sum(nvl(SALDOS_DIAS,0)) as saldos_dias 
from no_causa_vacac  
where 
num_doc =  '$num_doc'  and  id_tipo_doc = $id_tipo_doc 
and ID_CAUSA_VACAC != $id_causa_vacac
--and TO_DATE('$fecha_termina','yyyy-mm-dd') <= FECHA_FIN 
and FECHA_INI <= TO_DATE('$fecha_termina','yyyy-mm-dd') 
EOD;
                //Ejecutar SQL
                $records_vac = CN_TABLE::executeSQL($sql);

                $dias_vac = $records_vac[0]['saldos_dias'] * 360 / 15;
                $this->logMessage($records_vac[0]['saldos_dias'] . "[Liquidación Definitiva] dias_vac: " . $dias_vac);


                $fecha_ini_causa_vac = $fecha_ini = $records[0]['fecha_ini'];
                $fecha_fin = $fecha_termina;

                $dias = CN_TABLE::diasEntreFechas($fecha_ini, $fecha_fin, false);

                //Se toman dias de la tabla de nombramientos que posee hasta el dia que trabaja en fecha_termina
                $dias = $dias + $dias_vac;
            }
        }
        //Prima servicios proporcional - Julio 1 anterior a la fecha de retiro y hasta la misma fecha de retiro
        elseif ($id_concep_nomina == 16) {

            $anho_ini = $record['anho_ini'];
            /*
             * Caso CEV rango diferente - 20190724
             * Se verifica que para el CEV tome igual que las demas entidades, ya que genera un calculo muy grande de dias - 20211013::LAVILA
             */
            if ($entidadCliente == 8111 || $entidadCliente == 9111) {
                $fecha_ini = ($anho_ini + 1) . '-01-01';
            } else {
                $fecha_ini = $anho_ini . '-07-01';
            }
            $date1 = new DateTime($fecha_ini);
            $date2 = new DateTime($fecha_ingreso);

            if ($date2 > $date1) {
                $fecha_ini_causa_vac = $fecha_ini_ka = $fecha_ingreso;
                $dias = CN_TABLE::diasEntreFechas($fecha_ingreso, $fecha_termina, false);
            } else {
                $fecha_ini_causa_vac = $fecha_ini_ka = $fecha_ini;
                $dias = CN_TABLE::diasEntreFechas($fecha_ini, $fecha_termina, false);
            }
            //Se toman dias de la tabla de nombramientos que posee hasta el dia que trabaja en fecha_termina
            $dias = $dias;
        }
        //Prima de navidad proporcional - Enero 1 a la fecha de retiro
        elseif ($id_concep_nomina == 17 || $id_concep_nomina == 20 || $id_concep_nomina == 18) {

            $fecha_ini = $record['fecha_ini'];

            $date1 = new DateTime($fecha_ini);
            $date2 = new DateTime($fecha_ingreso);
            //fecha_terminacion
            $date3 = new DateTime($fecha_termina);

            /*
             * Validar que la fecha de terminacion sea mayor a la fecha inicial
             */
            if ($date3 > $date1) {

                /*
                 * Si la fecha de ingreso del funcionario es posterior a la fecha 1 de enero del mismo anho, 
                 * debe tomar solo desde la fecha de ingreso del funcionario
                 */
                if ($date2 > $date1) {
                    $fecha_ini_causa_vac = $fecha_ini_ka = $fecha_ingreso;
                    $dias = CN_TABLE::diasEntreFechas($fecha_ingreso, $fecha_termina, false);
                } else {
                    $fecha_ini_causa_vac = $fecha_ini_ka = $fecha_ini;
                    $dias = CN_TABLE::diasEntreFechas($fecha_ini, $fecha_termina, false);
                }
            } else {
                $dias = 0;
            }


            //Se toman dias de la tabla de nombramientos que posee hasta el dia que trabaja en fecha_termina
            $dias = $dias;

            if ($id_concep_nomina == 18) {
                //Caso CEV rango diferente - 20190724
                if ($entidadCliente == 8 || $entidadCliente == 9) {
                    $this->logMessage("[Liquidación Retroactivo Def] Caso CEV rango diferente.");
                } else {
                    $dias = 0;
                }
            }
        }
        //Dias de proporcionalidad bonificacion por servicios - 20140224 
        elseif ($id_concep_nomina == 11) {

            /*
             * Registro ultimo de bonificacion
             */
            //Sql
            $sql = <<<EOD
select * from no_bonifica_servicios
where 
num_doc =  '$num_doc'  and  id_tipo_doc = $id_tipo_doc
and to_date('$fecha_termina','yyyy-mm-dd') between fecha_ingresa and fecha_bonifica
order by fecha_bonifica desc 
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) > 0) {

                //Consulta para dias de otros periodos de vacaciones no tomados - 20130620
                $fecha_ini_causa_vac = $fecha_ingresa = $records[0]['fecha_ingresa'];

                $date1 = new DateTime($fecha_ingresa);
                $date2 = new DateTime($fecha_termina);

                if ($date2 > $date1) {
                    $dias = CN_TABLE::diasEntreFechas($fecha_ingresa, $fecha_termina, false);
                }

                $dias = $dias;
            }
        } else {
            $this->logMessage("[Liquidación Retroactivo Def] Id de concepto sin identificar.");
//            $dias = 360;
        }

        $fecha_ini = $fecha_ingreso;
        $fecha_fin = $fecha_termina;

        /**
         * Calculo dias certif otra entidad - 20130702
         */
        //Sql
        $sql = <<<EOD
select 
case when FECHA_DESDE < TO_DATE('$fecha_ini','yyyy-mm-dd') then TO_DATE('$fecha_ini','yyyy-mm-dd') else FECHA_DESDE end as FECHA_INI,
case when FECHA_HASTA > TO_DATE('$fecha_fin','yyyy-mm-dd') then TO_DATE('$fecha_fin','yyyy-mm-dd') else FECHA_HASTA end as FECHA_fin,
case when FECHA_HASTA > TO_DATE('$fecha_fin','yyyy-mm-dd') then TO_DATE('$fecha_fin','yyyy-mm-dd') else FECHA_HASTA end 
- 
case when FECHA_DESDE < TO_DATE('$fecha_ini','yyyy-mm-dd') then TO_DATE('$fecha_ini','yyyy-mm-dd') else FECHA_DESDE end as  DIAS, 

ID_CERTIF_OTRA_ENTIDAD,
ID_TIPO_DOC,
NUM_DOC,
NUM_DOC_SOP,
FECHA_SOPORTE,
OBSERVACIONES,
FECHA_DESDE,
FECHA_HASTA,
NUM_DIAS,
aplica_liquidacion

from NO_CERTIF_OTRA_ENTIDAD

where
(
    FECHA_DESDE between TO_DATE('$fecha_ini','yyyy-mm-dd') and TO_DATE('$fecha_fin','yyyy-mm-dd')
    or 
    FECHA_HASTA between to_date('$fecha_ini','yyyy-mm-dd') and to_date('$fecha_fin','yyyy-mm-dd')
)               
AND num_doc = '$num_doc'
AND id_tipo_doc = $id_tipo_doc
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        foreach ($records as $key => $value) {

            $fecha_ini_otra = $value['fecha_ini'];
            $fecha_fin_otra = $value['fecha_fin'];
            $aplica_liq = $value['aplica_liquidacion'];

            if ($aplica_liq == 1) {
                $dias_otra_entidad_liq += CN_TABLE::diasEntreFechas($fecha_ini_otra, $fecha_fin_otra, false);
            }
            $dias_otra_entidad += CN_TABLE::diasEntreFechas($fecha_ini_otra, $fecha_fin_otra, false);
        }

        $this->logMessage("[Liquidación Agrupación] Dias de otra entidad y dias desde fecha_ingreso: " . $dias_otra_entidad);



        /*
         * Claculo de dias de novedad de kardex que afectan antiguedad
         */
        /*
         * Se cambio a fechas contando dias habiles - 20130527
         * Se cambia a FECHA_RANGO_SIN_TREINTAYUNO. Si la novedad tiene una fecha de terminación 
         * mayor a la fecha retiro solo debe tener en cuenta hasta la fecha de retiro. - 20130827
         * Se anexa filtro de estado activo - 20131202
         * $fecha_ini_ka = $fecha_ini_causa_vac, para que tome como fecha inicial la de la novedad de vac o bonif, la ultima - 20150218
         */
        $fecha_ini_ka = $fecha_ini_causa_vac;
        //Sql
        $sql = <<<EOD
select nvl(sum(dias),0) as dias from(
  select 
  dias_habiles_cant( to_date(novka.fecha_ini,'yyyy-mm-dd'), to_date(novka.fecha_fin,'yyyy-mm-dd') ) as dias_hab,
  (to_date(novka.fecha_fin,'yyyy-mm-dd') - to_date(novka.fecha_ini,'yyyy-mm-dd')) + 1  as dias_cal,  
    
   FECHA_RANGO_SIN_TREINTAYUNO(
        case when TO_DATE(NOVKA.FECHA_INI,'yyyy-mm-dd')  < TO_DATE('$fecha_ini_ka','yyyy-mm-dd') 
    then TO_DATE('$fecha_ini_ka','yyyy-mm-dd') else TO_DATE(NOVKA.FECHA_INI,'yyyy-mm-dd') end
    ,
    case when TO_DATE(NOVKA.FECHA_FIN,'yyyy-mm-dd')  > TO_DATE('$fecha_fin_ka','yyyy-mm-dd') 
    then TO_DATE('$fecha_fin_ka','yyyy-mm-dd') else TO_DATE(NOVKA.FECHA_FIN,'yyyy-mm-dd') end
    ) as dias,
                
  novka.* ,
  tipnov.afecta_antigu,
  tipnov.afecta_alimen
  from no_novedad_kardex novka
  join no_tip_nov_ka tipnov 
  on novka.id_tip_nov_ka = tipnov.id_tip_nov_ka
  and tipnov.afecta_antigu = 1 
  where
    (
        novka.fecha_ini between to_date('$fecha_ini_ka','yyyy-mm-dd') and to_date('$fecha_fin_ka','yyyy-mm-dd')
        or novka.fecha_fin between to_date('$fecha_ini_ka','yyyy-mm-dd') and to_date('$fecha_fin_ka','yyyy-mm-dd')
                
        or
        
        TO_DATE('$fecha_ini_ka','yyyy-mm-dd') between novka.fecha_ini and NOVKA.FECHA_FIN
        or 
        TO_DATE('$fecha_ini_ka','yyyy-mm-dd') between novka.fecha_ini and NOVKA.FECHA_FIN
    )
    AND novka.num_doc = '$num_doc'
    AND novka.id_tipo_doc = $id_tipo_doc
    and novka.estado = 1
) 
EOD;
        //Ejecutar SQL
        $recordsKa = CN_TABLE::executeSQL($sql);

        $dias_kardex = $recordsKa[0]['dias'];

        //Restar dias
        //no restar dias de kardex si es concepto 1011, ya que al registrar la novedad kardex este corre los dias de bonificacion - 20140903
        //no restar dias de kardex si es concepto 1008,1009,1010, ya que al registrar la novedad kardex este corre los dias de vacaciones - 20141121
        //se habilita la resta,  esto se controla por medio de solo restar nov de kardex del ultimo periodo de causa de vac y bonif servc - 20150218
        if ($id_concep_nomina != 11 && $id_concep_nomina != 8 && $id_concep_nomina != 9 && $id_concep_nomina != 10) {
            $dias_liq = $dias - $dias_kardex;
        } else {
            $dias_liq = $dias - $dias_kardex;
        }

        /*
         * Calcula de concepto 1008
         */
        if ($id_concep_nomina == 8) {

            $num_dias_vac = 15;
            if ($entidadCliente == 9) {
                $num_dias_vac = 25; //dias cev publica - 20191126
            }

            $dias_liq = ($dias_liq * $num_dias_vac) / 360; //Dias completos
            $dias_liq_mod = fmod($dias_liq, 1); //Se agrego los dias (decimales) para calculo completo de los dias de vacaciones - 20140424
            //$dias_base = round($dias_liq);
            $dias_base = $dias_liq - $dias_liq_mod; //Se quita redondeo de los dias para tomar dias completos - 20140521

            $this->logMessage("[Liquidación Definitiva] Concepto 1008 - Dias liquidacion: " . $dias_liq . " - Dias Base: " . $dias_base . " - Dias Mod: " . $dias_liq_mod);

            //Dias con festivos
            //Empieza a contar desde el siguiente dia habil
            //Sql
            $sql = <<<EOD
select 
DIAS_HABILES(TO_DATE('$fecha_termina','yyyy-mm-dd'), 1),
DIAS_HABILES( DIAS_HABILES(TO_DATE('$fecha_termina','yyyy-mm-dd'), 1) , $dias_base - 1),
DIAS_HABILES( DIAS_HABILES(TO_DATE('$fecha_termina','yyyy-mm-dd'), 1) , $dias_base - 1) - DIAS_HABILES(TO_DATE('$fecha_termina','yyyy-mm-dd'), 1) + 1 as dias from DUAL
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);

            /*
             * Validar dias base mayor a 0 - 20141023
             */
            if ($dias_base <= 0) {
                $records[0]['dias'] = 0;
                $dias_base = 0;
            }

            /*
             * Para el CEV privada toma dias completos no los pone en el calendario concepto 1008 - 20191015
             * CEV PUB - 20191126
             */
            if ($entidadCliente == 8 || $entidadCliente == 9) {
                $dias_liq = $dias_base + round($dias_liq_mod, 2);
            } else {
                $dias_liq = $records[0]['dias'] + round($dias_liq_mod, 2); //redondeo a dos decimales - 20140728 
            }
        }


        /**
         * Calculo de dias
         */
        $this->logMessage("[Liquidación Retroactivo Def] Dias liquidacion: " . $dias_liq . " - Dias Base: " . $dias_base . " - Dias Kardex: " . $dias_kardex);
        $dias_array = array(
            'num_dias' => $dias_liq,
            'dias_otra_entidad' => $dias_otra_entidad - $dias_otra_entidad_liq,
            'dias_otra_entidad_liq' => $dias_otra_entidad_liq,
            'num_dias_base' => $dias_base
        );
        return $dias_array;
    }

    /**
     * Procesa la liquidacion para el periodo, funcionario y concepto nomina
     * @param type $id_periodo
     * @param type $num_doc
     * @param type $id_tipo_doc
     * @param type $id_concep_nomina
     * @param type $record_liq
     * @param type $arrayConstantes
     * @param type $id_periodo_ajuste
     */
    private function liquidar($id_periodo, $num_doc, $id_tipo_doc, $id_concep_nomina, $record_liq, $arrayConstantes, $id_periodo_ajuste) {
        $this->logMessage("[Liquidación Retroactivo Def] Liquidar: periodo " . $id_periodo .
                " - funcionario " . $num_doc . " - concepto nomina " . $id_concep_nomina);

        /**
         * Varibles
         */
        $arrayParametros = array();
        $valor_liquidado = 0;
        $fecha_desde = $record_liq['fecha_ingreso'];
        $fecha_hasta = $record_liq['fecha_termina'];
        $fecha_retiro = $record_liq['fecha_retiro'];
        $num_dias = $record_liq['num_dias'];
        $num_dias_base = $record_liq['num_dias_base'];

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }
            $int++;
        }

        /*
         * Valor Base y porcentaje
         */
        $porcentaje = 'null';
        $valor_base = 'null';

        /*
         * Cargar fórmulas por concepto
         * Se modifico formula Para aporte en salud, pensión y FSP  existe un tope máximo de aporte de 25 SMLV
         * se toma del id_concep_nomina asociado al descuento - 20130814
         */
        //Sql
        $sql = <<<EOD
select distinct * from no_formula 
   WHERE id_concep_nomina =   (    
   
  select distinct 
  nvl( id_concep_nomina_ss, ID_CONCEP_NOMINA) as ID_CONCEP_NOMINA 
  from
  (
  
      select 
      formula.ID_FORMULA,
      formula.ID_CONCEP_NOMINA,
      formula.FORMULA,
      formula.NOMBRE,
      formula.COD_TIPO,
      foncon.id_descuento_ss,
      des.id_concep_nomina as id_concep_nomina_ss
      from no_formula formula
      left join no_fondo_concepto foncon
      on formula.id_concep_nomina = foncon.id_concep_nomina
      left join no_descuento_ss des
      on foncon.id_descuento_ss = des.id_descuento_ss
      where formula.id_concep_nomina = $id_concep_nomina 
  
  )

)   
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        /*
         * Valida si posee formula el concepto
         */
        if (count($records) > 0) {
            $this->logMessage("[Liquidación Retroactivo Def] Entro a calcular Formula.");

            foreach ($records as $value) {

                //se adiciona un nuevo campo de formula para completar la retencion que es muy grande el proceso - 20210415::LAVILA
                $formula = $value['formula'] . $value['formula_adic'];
                $this->logMessage("[Liquidación Retroactivo Def] Formula Inicial: " . $formula);


                /*
                 *  Buscar las constantes, variables, fórmulas(parametros) y agrupaciones que use la fórmula
                 */
                //Reemplazo de constantes            
                $formula = $this->reemplazoConstante($formula, $arrayConstantes);
                $this->logMessage("[Liquidación Retroactivo Def] Formula Constante: " . $formula);

                /*
                 * Reemplaza en la consulta los filtros y valores del SQL, que vienen en el record
                 * Ejemplo: select raz_soc from id_cia where id_cia = $id_cia
                 * Reemplaza $id_cia por el valor en el record
                 */
                if ($record_liq['porcentaje'] == '' || $record_liq['porcentaje'] == null) {
                    $record_liq['porcentaje'] = 0;
                }
                $formula = CN_TABLE::reemplazoConsulta($formula, $record_liq);
                $this->logMessage("[Liquidación Retroactivo Def] Formula consulta los filtros: " . $formula);

                /*
                 * Cambio en la formula de A por (C1+C2)
                 */
                $vars = array();

                CN_TABLE::getVarsInFormula($vars, $formula);

//        var_dump($vars);

                foreach ($vars as $var) {
                    if (substr($var, 0, 1) == 'A') {
                        /*
                         * Cambio de A1 por relacion con los conceptos C1
                         * Ejemplo: 'A1' => '0'
                         */
                        $agrup = $this->reemplazoAgrupacion(substr($var, 1));
                        $this->logMessage("[Liquidación Retroactivo Def] Agrupacion: " . $agrup);

                        $formula = str_replace('{' . $var . '}', $agrup, $formula);
                    }
                }
                $this->logMessage("[Liquidación Retroactivo Def] Formula parametrosFormula y reemplazoAgrupacion: " . $formula);


                /*
                 * Parser de la formula para obtener parametros(variables)
                 * Ejemplo: 'A1' => '0',
                 * 'C1' => '0'
                 */
                $arrayParametros = $this->parametrosFormula($formula);


                /*
                 * Obtener resultados de los parametros(variables)
                 * Ejemplo: $arrayParametros = array(
                 * 'C1' => '0',
                 * 'C2' => '0'
                 * );
                 */
                $arrayParametros = $this->resultadoParametros($arrayParametros, $record_liq, $id_periodo_ajuste);


                /*
                 * Reemplazo de parametros(variables) a la formula
                 * Ejemplo: $arrayParametros = array(
                 * 'C1' => '1100',
                 * 'C2' => '55'
                 * );
                 */
                $formula = $this->reemplazoParametros($formula, $arrayParametros);
                $this->logMessage("[Liquidación Retroactivo Def] Formula Final: " . $formula);


                /*
                 * Ejecutar fórmula
                 * Ejemplo: ( 0 == 0 ? {C1} * $porcentaje : false )
                 * Retorna false  si no cumple con la condicion
                 */
                $formula = str_replace('{', ' ', $formula);
                $formula = str_replace('}', ' ', $formula);
                $result = CN_TABLE::aplicarEval($formula);


                /*
                 * No cumple con la condicion
                 */
//                if ($result === false) {
                if ($result == '-9999' || $result == -9999) {
                    $this->logMessage("[Liquidación Retroactivo Def] Formula No cumple con la condicion: " . $formula);
                    $result = 0;
                }


                /*
                 * Acumulan resultados de liquidacion
                 */
                $valor_liquidado += $result;
                /*
                 * Si es por porcentaje
                 */
                if ($record_liq['porcentaje'] != '' || $record_liq['porcentaje'] != null) {
                    /*
                     * Tipo de formula
                     * V - Valor base 
                     * R - Valor restado 
                     * F - Valor de la fórmula (Uso normal)
                     */
                    if ($value['cod_tipo'] == 'V') {
                        $this->logMessage("[Liquidación Retroactivo Def] Formula CodTipo: " . $value['cod_tipo']);

                        /*
                         * Valor Base y porcentaje
                         */
                        $porcentaje = $record_liq['porcentaje'];
                        $valor_base = ($result * 100) / $record_liq['porcentaje'];
                    }
                }
            }
        } else {

            /**
             * Logica de N
             */
            if ($record_liq['caracter'] == 'N') {
                $this->logMessage("[Liquidación Retroactivo Def] Logica de N - Concepto: " . $id_concep_nomina);

                /*
                 * Resta % (se puede para el valor) 
                 */
                //sumar devengados
                //Sql
                $sql = <<<EOD
select 
nvl(sum(liqnom.valor_liquidado),0) as valor_liquidado  
from no_liquida_nomina liqnom
join no_concep_nomina connom
on liqnom.id_concep_nomina = connom.id_concep_nomina
and connom.operador = 1
where
liqnom.id_periodo = $id_periodo_ajuste
and liqnom.id_tipo_doc = $id_tipo_doc
and liqnom.num_doc = '$num_doc' 
EOD;
                //Ejecutar SQL
                $records_deveng = CN_TABLE::executeSQL($sql);

                if (count($records_deveng) > 0) {

                    $devengado = $records_deveng[0]['valor_liquidado'];

                    //obtener porcentaje de max_ded_noley
                    $devengado_por = ($devengado * $max_ded_noley) / 100;

                    /*
                     * Si es por porcentaje
                     */
                    if ($record_liq['porcentaje'] != '' || $record_liq['porcentaje'] != null) {

                        $valor_logica_n = (0 * $record_liq['porcentaje']) / 100;
                    } else {
                        $valor_logica_n = $record_liq['valor'];
                    }

                    //Validar resta - operar
                    if (($devengado_por - $valor_logica_n - $valor_sumatoria_logica_n) <= 0) {

                        $valor_liquidado = $valor_logica_n;
                        $valor_sumatoria_logica_n += $valor_liquidado;
                    } else {

                        $valor_liquidado = 0;
                    }
                } else {

                    $this->logMessage("[Liquidación Retroactivo Def] No hay valor devengados.");
                    $valor_liquidado = 0;
                }
            } else {
                /*
                 * La liquidación se hacer por 2 espacios temporales:
                 *
                 * - Mensual
                 * En cuyo caso, todos los meses tienen una duración de 30 días
                 * - Por días calendario
                 * En cuyo caso se hace por la cantidad de días especificada en no_concepto_periodo.num_dias
                 * 
                 * Esta especificación, si se hace mensual o usando los días, lo especifica la variable no_concep_nomina.dias_calendario
                 * 
                 * Si se hace una interrupción en un concepto, digamos algún cargo temporal, debe liquidarse el valor del concepto asÍ: 
                 * Ejemplo: $valor = ($valor_liquidado_concepto_mes/30)*$num_dias
                 */

                /*
                 * Si es por porcentaje y diferente de 0
                 */
                if (($record_liq['porcentaje'] != '' || $record_liq['porcentaje'] != null) && $record_liq['porcentaje'] != 0) {
                    $this->logMessage("[Liquidación Retroactivo Def] Calcular porcentaje - " . $record_liq['porcentaje']);


                    //Sql
                    $sql = <<<EOD
select * from no_liquida_nomina 
where id_concep_nomina = (select id_concep_basica from no_param_concep where id_param_concep = 1)
and id_periodo = $id_periodo_ajuste
and id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc' 
EOD;
                    //Ejecutar SQL
                    $records = CN_TABLE::executeSQL($sql);

                    if (count($records) <= 0) {
                        $records[0]['valor_liquidado'] = 0;
                    }

                    //Resultado del calculo de porcentaje
                    $result = ($records[0]['valor_liquidado'] * $record_liq['porcentaje']) / 100;

                    /*
                     * Valor Base y porcentaje
                     */
                    $porcentaje = $record_liq['porcentaje'];
                    $valor_base = $records[0]['valor_liquidado'];
                } else {
                    $this->logMessage("[Liquidación Retroactivo Def] Calcular valor - " . $record_liq['valor']);

                    if (!is_null($record_liq['num_dias'])) {

                        /*
                         * usa_dias_calen
                         */
                        if ($record_liq['usa_dias_calen'] == 0) { //Mensual
                            $num_dias = 30;
                            $num_dias = $record_liq['num_dias']; // ? Revisar
                        } else { //Por días calendario
                            $num_dias = $record_liq['num_dias'];
                        }

                        $result = ($record_liq['valor'] / 30) * $num_dias;
                    } else {
                        $num_dias = 'null';
                        $result = $record_liq['valor'];
                    }
                }

                $valor_liquidado += $result;
            }
        }


        //Dias de proporcionalidad bonificacion por servicios - 20140224
        if ($id_concep_nomina == 11) {
            $valor_liquidado = round(($valor_liquidado * $num_dias) / 360);
        }

        /**
         * Registro de liquida nomina por concepto 
         */
        /*
         * Valida creacion de registro
         */
        if ($valor_liquidado > 0) {

            $this->logMessage("[Liquidación Retroactivo Def] El valor liquidado es: " . $valor_liquidado);


            //Caso CEV tome fecha termina - 20190724
            if ($entidadCliente == 8 || $entidadCliente == 9) {
                $fecha_retiro = $fecha_hasta;
            }

            /*
             * Crear nueva liquidación
             * 
             * Asignar valores encontrados en persona
             */
            //insert into no_liquida_nomina (id_liquida_nomina,id_tipo_doc,num_doc,id_concep_nomina,
            //id_periodo,valor_liquidado,fecha_desde,fecha_hasta,num_dias, valor_base, porcentaje) 
            //values ('9','1','17304849','1','13','257100',to_date('22/11/12','DD/MM/RR'),
            //to_date('22/11/12','DD/MM/RR'),'30');
            //Sql
            $sql = <<<EOD
insert into no_liquida_nomina (id_tipo_doc, num_doc, id_concep_nomina,
        id_periodo,valor_liquidado,fecha_desde,fecha_hasta,num_dias, valor_base, porcentaje, num_dias_base, id_periodo_ajuste ) 
        values ( $id_tipo_doc, '$num_doc', $id_concep_nomina, $id_periodo, round($valor_liquidado), 
        to_date('$fecha_desde','YYYY-MM-DD'), to_date('$fecha_retiro','YYYY-MM-DD'), $num_dias,
            round($valor_base), $porcentaje, $num_dias_base, $id_periodo_ajuste ) 
EOD;
            //Ejecutar SQL
            CN_TABLE::executeSQL($sql);
        } else {

            $this->logMessage("[Liquidación Retroactivo Def] El valor_liquidado es menor a cero.");
        }
    }

    /**
     * Reemplaza en la formula las constantes por valores de la tabla NO_CONSTANTE
     * Ejemplo: $con_1
     * @param type $formula
     * @param type $arrayConstantes
     */
    private function reemplazoConstante($formula, $arrayConstantes) {

        /*
         * Recorrer array de Constantes
         */
        foreach ($arrayConstantes as $key => $value) {

            $formula = str_replace($key, $value['valor'], $formula);
        }

        return $formula;
    }

    /**
     * Reemplaza los parametros(variables) a la formula
     * Ejemplo: $key: C1 / $value: valor - 2+5
     * @param type $formula
     * @param type $arrayParametros
     */
    private function reemplazoParametros($formula, $arrayParametros) {

        /*
         * Recorrer array de Parametros
         */
        foreach ($arrayParametros as $key => $value) {

            $formula = str_replace('{' . $key . '}', $value, $formula);
        }

        return $formula;
    }

    /**
     * Obtener resultados de los parametros(variables)
     * Ejemplo: 'C1' => '0'
     * @param type $arrayParametros
     * @param type $record_liq
     */
    private function resultadoParametros($arrayParametros, $record_liq, $id_periodo_ajuste) {

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }
            $int++;
        }

        //concepto origen de formula de liquidacion - 20211029::LAVILA
        $id_concep_nomina_liq = $record_liq['id_concep_nomina'];
        $num_doc = $record_liq['num_doc'];
        $id_tipo_doc = $record_liq['id_tipo_doc'];
        $vig_fin = $record_liq['vig_fin'];

        /*
         * Tag definitiva cambia caracter por M - 20141014
         */
        $tag_def = $record_liq['tag_def'];

        /*
         * Recorrer array de Parametros
         */
        foreach ($arrayParametros as $key => $value) {

            //Sacar caracter y numero(id_concep_nomina) para consulta
            $caracter = substr($key, 0, 1);
            $id_concep_nomina = substr($key, 1);

            //Valida Tag definitiva
            if ($tag_def == 1) {
                $caracter = "M";
            }

            //Para el calculo de 1016 tome el C1 y no el P1 - 20190724
            if ($id_concep_nomina == 1 && $caracter == "P") {
                $caracter = "C";
            }

            /**
             * Se cambia consulta U por W, para treaer el ultimo registro encontrado por periodo de ajuste en liquidacion_nomina - 20170621/20211029
             * Se omite para CYC, normatividad retro - 20230804::LAVILA, Se omite para SGC, normatividad retro - 20230831::LAVILA
             */
            //(SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
            if ($entidadCliente != 4 && $entidadCliente != 1) {
                if ($caracter . $id_concep_nomina == 'U11') {
                    $this->logMessage("[Liquidación Retroactivo] Cambio de ultimo valor por consulta W11->U11:: " . $caracter . $id_concep_nomina);
                    $caracter = 'W';
                }
                if ($caracter . $id_concep_nomina == 'U16') {
                    $this->logMessage("[Liquidación Retroactivo] Cambio de ultimo valor por consulta W16->U16:: " . $caracter . $id_concep_nomina);
                    $caracter = 'W';
                }
            }
            //Solo para 1017 y 1020 de liquidacion, tomar para el 1011 lo pagado en la mensual/adicional del año - 20211029::LAVILA
            if (($id_concep_nomina_liq == 17 || $id_concep_nomina_liq == 20) && $caracter . $id_concep_nomina == 'V11') {
                $this->logMessage("[Liquidación Retroactivo] Se le suma 1011 del periodo de 2021 si es por acumulado V11:: ");
                //Sql
                $sql = <<<EOD
select 
nvl(sum(liqnom.valor_liquidado),0) as valor 
from no_liquida_nomina liqnom 

join no_periodo per on per.id_periodo = liqnom.id_periodo 
left join no_nombramiento_v nom on nom.id_tipo_doc = liqnom.id_tipo_doc and nom.num_doc = liqnom.num_doc 
left join no_periodo per2 on per2.id_periodo = nom.id_periodo 

where    1 = 1  
and per.id_anhos || lpad(per.id_meses, 2, '0')  between  $vig_fin || lpad( 1, 2, '0')  and $vig_fin || lpad( 12, 2, '0')  
and liqnom.num_doc =  '$num_doc'   and liqnom.id_tipo_doc = $id_tipo_doc 
and liqnom.id_concep_nomina in ( $id_concep_nomina  ) 
and per.id_tipo_periodo in (1,2) 
EOD;
                //Ejecutar SQL
                $record = CN_TABLE::executeSQL($sql);
                if (count($record) > 0) {
                    $valor_mens_concep = $record[0]['valor'];
                }
            } else {
                $valor_mens_concep = 0;
            }

            $this->logMessage("[Liquidación Retroactivo Def] Caracter: " . $caracter . ", numero: " . $id_concep_nomina);

            /*
             * Obtener consulta por caracter
             */
            //Sql
            $sql = <<<EOD
select * from NO_CONSULTA where caracter = '$caracter' 
EOD;
            //Ejecutar SQL
            $record = CN_TABLE::executeSQL($sql);

            //Validar registros SQL
            if (count($record) > 0) {

                $consulta = $record[0]['consulta'];

                //Reemplazo de id_concep_nomina
                $consulta = str_replace('$id_concep_nomina', $id_concep_nomina, $consulta);
                $consulta = str_replace('$id_periodo_ajuste', $id_periodo_ajuste, $consulta);

                /*
                 * Reemplaza en la consulta los filtros y valores del SQL, que vienen en el record
                 * Ejemplo: select raz_soc from id_cia where id_cia = $id_cia
                 * Reemplaza $id_cia por el valor en el record
                 */
                $consulta = CN_TABLE::reemplazoConsulta($consulta, $record_liq);

                /*
                 * Ejecutar SQL de consulta
                 */
                //Sql
                $sql = <<<EOD
$consulta  
EOD;
                //Ejecutar SQL
                $record = CN_TABLE::executeSQL($sql);

                //Validar registros SQL
                if (count($record) > 0) {
                    $valor = $record[0]['valor'] + $valor_mens_concep;
                } else {
                    $valor = 0;
                }
            } else {
                $valor = 0;
            }

            $arrayParametros[$key] = $valor;
        }

        return $arrayParametros;
    }

    /**
     * Parser de la formula para obtener parametros(variables)
     * Ejemplo: 'C1' => '0'
     * @param type $formula
     * @param type $arrayParametros
     */
    private function parametrosFormula($formula) {

        $vars = array();

        CN_TABLE::getVarsInFormula($vars, $formula);

        foreach ($vars as $var) {
            $arrayParametros[$var] = 0;
        }

//        var_dump($arrayParametros);
//        exit();
//        $arrayParametros = array(
//            'C1' => '0',
//            'C2' => '0',
//            'T1' => '0',
//            'A1' => '0'
//        );

        return $arrayParametros;
    }

    /**
     * Reemplaza las agrupaciones por los parametros(variables)
     * Ejemplo: A1 -> (+C1-C2-T1)
     * @param type $id_agrup_var
     */
    private function reemplazoAgrupacion($id_agrup_var) {

        $agrup = '( ';

        /*
         * Ejecutar SQL de agrupciones
         */
        //Sql
        $sql = <<<EOD
select 
agru.*,
agru.tipo_valor as caracter
from
no_agrup_deta agru
where agru.id_agrup_concepto = $id_agrup_var  
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        /*
         * Recorrer registros 
         */
        foreach ($records as $value) {

            $operador = ($value['operador'] == 1 ? '+' : '-');

            //Concatenar todas las agrupaciones
            $agrup .= $operador . '{' . $value['caracter'] . $value['id_concep_nomina'] . '}';
        }

        $agrup .= ' )';

        return $agrup;
    }

    /**
     * Si posee novedad de kardex para el mes y anho - 20140610
     * @param type $anho
     * @param type $mes
     */
    public function tieneNovKa($id_tipo_doc, $num_doc, $anho, $mes) {

        $cant = 0;

        //Sql
        $sql = <<<EOD
select count(num_doc) as cant from(              
  select      
  novka.*,
  tipnov.afecta_antigu,
  tipnov.afecta_alimen
  from no_novedad_kardex novka
  join no_tip_nov_ka tipnov 
  on novka.id_tip_nov_ka = tipnov.id_tip_nov_ka
  and tipnov.afecta_antigu = 1 
  where
    (
        to_date( '01/' || $mes || '/' || $anho, 'dd/mm/yyyy') between novka.fecha_ini and novka.fecha_fin
        or
        TRUNC(LAST_DAY( to_date( $mes || '/' || $anho, 'mm/yyyy')  )) between novka.fecha_ini and novka.fecha_fin
        
        or
        
        novka.fecha_ini between to_date( '01/' || $mes || '/' || $anho, 'dd/mm/yyyy')  
        and TRUNC(LAST_DAY( to_date( $mes || '/' || $anho, 'mm/yyyy')  ))
        or 
        novka.fecha_fin between to_date( '01/' || $mes || '/' || $anho, 'dd/mm/yyyy')  
        and TRUNC(LAST_DAY( to_date( $mes || '/' || $anho, 'mm/yyyy')  ))
        
    )
    AND novka.num_doc = '$num_doc'
    AND novka.id_tipo_doc = $id_tipo_doc
    and novka.estado = 1
)  
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);
        $cant = $records[0]['cant'];

        /*
         * valida que hay novedad de kardex en el mes y anho
         */
        if ($cant > 0) {
            return 1;
        }

        return 0;
    }

    /**
     * Calcular FSP aporte funcionario
     * @param type $valor_base
     * @param type $salario_minimo
     * @return int
     */
    private function valor_base_fsp($valor_base, $salario_minimo, $valor_base_vac = 0, $wdiasv = 0, $dias_liq, $num_doc, $id_periodo, $wvalor_base_extra = 0) {

        $this->logMessage("[Liquidación] valor_base_fsp:: valor_base: " . $valor_base . " - valor_base_vac: " . $valor_base_vac);
        $this->logMessage("[Liquidación] valor_base_fsp:: wdiasv: " . $wdiasv . " - dias_liq: " . $dias_liq);


        /*
         * WBASE=   BASE TOTAL que ya estamos hayando
         * WVRBASE=(WBASE/(WDIAST+WDIASV))*30
         * Sobre WVRBASE  verifica si debe calcular FSP y sobre ella misma ubicar el porcentaje 
         * Si aplica y tiene el porcentaje,  aplica el porcentaje sobre WBASE
         * 20131216
         */
        $valor = 0;
        $valorfps1 = 0;
        $valorfps2 = 0;
        $porcentaje = 0;
        $valor_bonif = 0;
        $valor_bonifs = 0;


        /**
         * Para las personas que tienen bonificacion por servicios se toma este valor proporcional a los dias laborados - 20140605
         */
        //Sql
        $sql = <<<EOD
select nvl(sum(valor_liquidado),0) as valor from no_liquida_nomina 
where num_doc = $num_doc and id_tipo_doc = 1 
and id_concep_nomina = (select no_param_concep.id_concep_bonif from no_param_concep where no_param_concep.id_param_concep = 1) 
and id_periodo = $id_periodo            
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        /*
         * Valida si posee formula el concepto
         */
        if (count($records) > 0 && $dias_liq > 0) {
            $valor_bonifs = $records[0]['valor']; //bonificacion completa
            $valor_bonif = (($valor_bonifs * $dias_liq) / 30); //bonificacion por dias laborales
        }
        $this->logMessage("[Liquidación] Valida si la persona - valor_bonif :: " . $valor_bonif);



        /*
         * Operaciones
         * Se separa el valor bonif del redondeo a 30 dias laborales, ya que en el proceso anterior ya se realiza su calculo para los 30 dias - 20150218
         */
        //$wvalor_base = (($valor_base - $valor_bonifs + $valor_bonif) / ($dias_liq + $wdiasv)) * 30;
        $wvalor_base = (($valor_base - $valor_bonifs) / ($dias_liq + $wdiasv) * 30 ) + ($valor_bonif);


        /**
         * Valida si la persona ingreso en el mes o se retira para tomar los dias en cuenta - 20140307
         */
        $this->logMessage("[Liquidación] Valida si la persona - wvalor_base :: " . $wvalor_base . " - Salario Minimo :: " . $salario_minimo);
        //Sql
        $sql = <<<EOD
select 
nom.* 
from no_nombramiento_v nom
where 
nom.id_tipo_doc = 1
and nom.num_doc = $num_doc
and (
nom.fecha_ingreso between (select per.fecha_ini from no_periodo per where per.id_periodo = $id_periodo) and (select per.fecha_fin from no_periodo per where per.id_periodo = $id_periodo)
)                
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);


        /*
         * Valida si ingreso en el mes de retiro - 20150320 
         */
        if (count($records) > 0) {
            $wvalor_base = $valor_base + $valor_base_vac + $valor_bonif;
            $this->logMessage("[Liquidación] Valida si posee formula el concepto - wvalor_base :: " . $wvalor_base);
        } else {

            //salario completo
            $wvalor_base = $wvalor_base_extra;
            $this->logMessage("[Liquidación] wvalor_base_extra :: " . $wvalor_base);
        }
        //Cambio de verificacion del valor base - 20131216
        if (($wvalor_base) > ($salario_minimo * 4) && ($wvalor_base) <= ($salario_minimo * 16)) {
            $porcentaje = 1;
        } elseif (($wvalor_base) > ($salario_minimo * 16) && ($wvalor_base) <= ($salario_minimo * 17)) {
            $porcentaje = 1.2;
        } elseif (($wvalor_base) > ($salario_minimo * 17) && ($wvalor_base) <= ($salario_minimo * 18)) {
            $porcentaje = 1.4;
        } elseif (($wvalor_base) > ($salario_minimo * 18) && ($wvalor_base) <= ($salario_minimo * 19)) {
            $porcentaje = 1.6;
        } elseif (($wvalor_base) > ($salario_minimo * 19) && ($wvalor_base) <= ($salario_minimo * 20)) {
            $porcentaje = 1.8;
        } elseif (($wvalor_base) > ($salario_minimo * 20)) {
            $porcentaje = 2;
        }

        /* INCI - 20140122
         * Patricia Montoya Falla, C.C. 35.462.698,
          Esperanza Verdugo, C.C.  46.662.659
          Yanerys Irina de la Hoz, C.C.  57.290.110
          Vladimir Yanken Cifuentes, C.C. 79.526.123
          Gustavo Pulido Casas, C.C. 93.288.443
         * 39773464
         */
        /* if ($num_doc == '35462698' || $num_doc == '46662659' || $num_doc == '57290110' || $num_doc == '79526123' || $num_doc == '93288443' || $num_doc == '51788859') {
          if (($valor_base + $valor_base_vac) > ($salario_minimo * 4) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 16)) {
          $porcentaje = 1;
          } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 16) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 17)) {
          $porcentaje = 1.2;
          } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 17) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 18)) {
          $porcentaje = 1.4;
          } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 18) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 19)) {
          $porcentaje = 1.6;
          } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 19) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 20)) {
          $porcentaje = 1.8;
          } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 20)) {
          $porcentaje = 2;
          }
          }
          //num_doc in (13507148, 51653492 ,79250331 ,52779827 ,20404209)
          if ($num_doc == '51653492' || $num_doc == '79250331') {
          $porcentaje = 0;
          }
         */
        /**
         * Se redondea valor al sumar al final y no $valorfps1 / $valorfps2, por separado  - 20140616
         */
        $this->logMessage("[Liquidación] valor_base_fsp:: valor_base: " . $valor_base);
//        $valorfps1 = round($valor_base * 0.5 / 100, -2);
//        $valorfps2 = round($valor_base * ($porcentaje - 0.5) / 100, -2);
        $valorfps1 = $valor_base * 0.5 / 100;
        $valorfps2 = $valor_base * ($porcentaje - 0.5) / 100;
        $this->logMessage("[Liquidación] valor_base_fsp:: valorfps1: " . $valorfps1 . " - valorfps2: " . $valorfps2);

        //se cambia el redondeo al sumar valores como esta en autoliquidacion
//        $valor = round(($valorfps1 + $valorfps2) - 1, -2);
        $valor = CN_TABLE::redondeoValor($valorfps1, -2) + CN_TABLE::redondeoValor($valorfps2, -2);

        $array_fsp = array(
            'valor_fsp' => $valor,
            'porcentaje_fsp' => $porcentaje
        );

        $this->logMessage("[Liquidación] valor_base_fsp:: valor_fsp: " . $valor . " - porcentaje_fsp: " . $porcentaje);

        return $array_fsp;
    }

}
